"""
module docs
"""
import turtle as tl
from time import sleep as pause

from menus import main_menu

def exibir_coordenadas(x: float, y: float) -> None:
    """Exibe as coordenadas de um clique do mouse."""

    print(f"Coordenadas do clique: x={x:0.0f}, y={y:0.0f}")
    
    # Exibe as coordenadas na tela com o tl
    tl.penup()
    tl.goto(x, y)
    tl.pendown()
    tl.write(f"({x:0.0f}, {y:0.0f})", font=("Arial", 12, "normal"))
    tl.stamp()


def falas(personagem: tl.Turtle, text: str) -> None:
    fala.goto(personagem.pos())
    fala.left(45)
    fala.fd(50)
    fala.color("white")
    fala.write(text,False,font=("arial",10,"normal"))
    pause(3)
    for i in range(4):
        fala.undo()

def habilita_clique() -> None:
    """Habilita o clique do mouse na tela.
    """

    tela = tl.Screen()
    tela.title("Clique para ver as coordenadas do mouse")
    tela.onclick(exibir_coordenadas)

def pinto_acha_cobra() -> None:
    """
    Lugar misterioso com um baú. O pinto entra na cena. "Eita, um baú totalmente estranho no meio dessa masmorra super perigosa." "Baús são legais. Com certeza deve ter algo legal dentro. Vou ver o que tem nele."
    O pinto vai até o baú e tenta abrir ele.
    O baú abre e sai uma cobra de dentro.
    "Vixe! Uma cobra!" - Diz o pinto se afastando do baú.
    "Calma pequeno pinto. Não sou uma cobra má." - Diz a cobra saindo do baú.p
    "Eu não acredito em você!" - Diz o pinto se afastando.
    "Por que você não acredita em mim?" - Pergunta a cobra.
    "Porque você é uma cobra!" - Diz o pinto.
    "Mas uma coisa não tem nada a ver com a outra." - Diz a cobra.
    "Por que eu deveria acreditar em você?" - Pergunta o pinto.
    "Porque o meu nome é python. Cobras com esse nome são legais." - Diz a cobra.
    "Python é aquele nome de uma linguagem de programação?" - Pergunta o pinto.
    "Sim, é isso mesmo!" - Responde a cobra.
    "Eu não quero fazer programa!" - Diz o pinto enquanto sai de cena
    "Volta aqui pinto, eu não vou fazer nada com você!" - Diz aacobra correndo atrás do pinto.
    Ambos saem de cena.
    """
    tl.addshape("sprites/fundos/fundo_1_bau_fechado.gif")
    tl.addshape("sprites/fundos/fundo_1_bau_aberto.gif")
    tl.addshape("sprites/personagens/pinto_.gif")
    tl.addshape("sprites/personagens/_pinto.gif")
    tl.addshape("sprites/personagens/_cobra.gif")
    bgpic.shape("sprites/fundos/fundo_1_bau_fechado.gif")
    pinto.shape("sprites/personagens/pinto_.gif")
    cobra.shape("sprites/personagens/_cobra.gif")
    pinto.goto(-281,-89)
    pinto.showturtle()
    pinto.goto(-132,-89)
    pause(2)
    falas(pinto, "Eita, um baú totalmente estranho no meio\n dessa masmorra super perigosa.")
    falas(pinto, "Baús são legais. Com certeza deve ter algo legal dentro. Vou ver o que tem nele.")
    pinto.goto(28,-89)
    pinto.goto(31,-16)
    pause(2)
    bgpic.shape("sprites/fundos/fundo_1_bau_aberto.gif")
    pause(1)
    cobra.goto(31,53)
    cobra.showturtle()
    falas(pinto, "Vixe! Uma cobra!")
    falas(cobra, "Calma pequeno pinto.\n Não sou uma cobra má.")
    falas(pinto, "Porque eu deveria acreditar em vc?")
    falas(cobra, "Porque o Meu nome é Python!\nCobras com esse nome são confiaveis...")
    falas(pinto, "Tipo aquela Linguagem de programação?\nSlk, Num compensa")
    pinto.shape("sprites/personagens/_pinto.gif")
    pause(1)
    pinto.goto(28,-89)
    pinto.goto(-281,-89)
    pinto.hideturtle()
    falas(cobra, "Volte aqui pintinho\nnão vou fazer voçê programar!")
    cobra.goto(28,-89)
    cobra.goto(-132,-89)
    cobra.hideturtle()
    

def pinto_foge_cobra():
    """
    Um lugar da masmorra sombria. Esse lugar tem mais de uma saída. Tem paredes e obstáculos.
    O pinto aparece correndo da cobra. "Ainda bem que eu já passei por aqui!" - Diz ele.
    O pinto então passa pelos lugares certos e vai na direção de cima.
    Enquanto isso a cobra chega no lugar e fica "perdida". "Que lugar estranho! No baú era melhor." - Diz ela.
    Então ela vai para baixo.
    Ambos fora de cena.
    """
    tl.addshape("sprites/fundos/fundo_2.gif")
    tl.addshape("sprites/personagens/_pinto.gif")
    tl.addshape("sprites/personagens/pinto_.gif")
    tl.addshape("sprites/personagens/_cobra.gif")
    tl.addshape("sprites/personagens/cobra_.gif")
    bgpic.shape("sprites/fundos/fundo_2.gif")
    pinto.shape("sprites/personagens/_pinto.gif")
    pinto.goto(286, -26)
    pinto.showturtle()
    pinto.goto(2, -28)
    falas(pinto, "Ainda bem que eu já passei por aqui")
    pinto.shape("sprites/personagens/pinto_.gif")
    pinto.goto(-1, 298)
    pinto.hideturtle()
    cobra.shape("sprites/personagens/_cobra.gif")
    cobra.goto(286, -26)
    cobra.showturtle()
    cobra.goto(2, -28)
    falas(cobra, "Que lugar estranho!\n No baú era melhor.")
    cobra.shape("sprites/personagens/cobra_.gif")
    cobra.goto(1, -285)
    cobra.hideturtle()

    ...
    
def pinto_acha_arma() -> None:
    """
    Nessa cena o pinto chega em uma nova sala estranha com um baú.
    "Por favor, que tenha algo legal nesse baú!" - Diz o pinto indo em direção ao baú.
    O pinto vai até o baú e após abrir ele, acha um lança-chamas. 
    "Isso com certeza vai servir!" - Diz ele segurando a arma e indo para uma outra sala.
    Após o pinto sair, a cobra chega na sala dizendo "Finalmente achei você, pinto maldito!" - Após isso o pinto sai de cena.
    "Volte aqui, eu vou pegar você!" - Diz a cobra.
    A cobra segue o pinto. Todos saem de cena.
    """
    # Autor do código: Guilherme Aleixo (20241144010020) 
    tl.addshape("sprites/fundos/fundo_3_bau_fechado.gif")
    tl.addshape("sprites/fundos/fundo_3_bau_aberto.gif")
    bgpic.shape("sprites/fundos/fundo_3_bau_fechado.gif")
    
    tl.addshape("sprites/personagens/pinto_.gif")
    tl.addshape("sprites/personagens/_pinto.gif")
    pinto.shape("sprites/personagens/pinto_.gif")
    
    pinto.hideturtle()
    pinto.goto(0, -352)
    
    pinto.showturtle()
    pinto.goto(0, -16)
    
    falas(pinto, "Por favor, que tenha algo legal nesse baú!")
    
    bgpic.shape("sprites/fundos/fundo_3_bau_aberto.gif")
    
    tl.addshape("sprites/objetos/lancachamas.gif")
    lanca_chamas = tl.Turtle(visible=False)
    lanca_chamas.up()
    lanca_chamas.shape("sprites/objetos/lancachamas.gif")
    
    lanca_chamas.goto(0, 64)
    lanca_chamas.showturtle()
    
    falas(pinto, "Isso com certeza vai servir!")
    
    lanca_chamas.hideturtle()
    
    tl.addshape("sprites/personagens/pinto_flamer_.gif")
    pinto.shape("sprites/personagens/pinto_flamer_.gif")
    
    pause(1)
    pinto.goto(0, -352)

def pinto_mata_cobra() -> None:
    """
    O pinto com a sua arma chega na nova sala da masmorra e fica mirando para a porta esperando a cobra.
    "Daqui não tem como errar..." - Diz o pinto.
    A cobra chega na sala indo em direção ao pinto. "Vou te alcançar!" Diz ela.
    Com a cobra se aproximando do pinto. O pinto aperta o gatilho e sai uma rajada de fogo na cobra; ela morre cremada.
    "Parece que agora eu não sou o 'pequeno pinto', né?" Diz o pinto.
    O pinto deixa o lança chamas no chão.
    "Vou voltar a explorar essa masmorra legal." Diz o pinto.
    Ele sai da cena.
    """
    ...

def main() -> None:
    """...main function duh"""
    scene_num = int(input(main_menu))
    while scene_num != 6:
        if scene_num == 1:
            pinto_acha_cobra()
        elif scene_num == 2:
            pinto_foge_cobra()
        elif scene_num == 3:
            pinto_acha_arma()
        elif scene_num == 4:
            pinto_mata_cobra()
        else:
            print("Cena não disponível")
        scene_num = int(input(main_menu))
    pass
            
if __name__ == "__main__":

    habilita_clique()
    
    tl.setup(600,600,None,None) #spawna a tela
    bgpic = tl.Turtle() #coloca a tartaruga principal de desenho
    bgpic.up()

    pinto = tl.Turtle(visible=False)
    pinto.up()
    

    cobra = tl.Turtle(visible=False)
    cobra.up()
    

    fala = tl.Turtle(visible=False)
    fala.up()

    main()
    
    tl.mainloop()